Summary: Ganglia Distributed Monitoring System
Name: ganglia
Version: 3.4.0
URL: http://ganglia.info/
Release: 2
License: BSD
Vendor: Ganglia Development Team <ganglia-developers@lists.sourceforge.net>
Group: System Environment/Base

Source0: %{name}-%{version}.tar.gz
Source1: %{name}-%{version}-gmond.conf
Source2: gmetad.aix.init
Source3: gmond.aix.init

Patch0: %{name}-%{version}-aix.patch
Patch1: %{name}-%{version}-aix2.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: AIX-rpm >= 6.1.0.0
BuildRequires: apr-devel  >= 1.3.12
BuildRequires: libconfuse-devel
BuildRequires: expat-devel >= 2.0.0
BuildRequires: pcre-devel >= 7.9
BuildRequires: rrdtool-devel
BuildRequires: patch, autoconf, automake, libtool, m4

%define conf_dir /etc/%{name}

%description
Ganglia is a scalable, real-time monitoring and execution environment


%package lib
Summary: Ganglia Meta daemon http://ganglia.sourceforge.net/
Group: System Environment/Base

Requires: AIX-rpm >= 6.1.0.0
Requires: libconfuse
Requires: expat >= 2.0.0
Requires: pcre >= 7.9

%description lib
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

The Ganglia shared libraries contain common libraries required by both gmond
and gmetad packages.


%package gmetad
Summary: Ganglia Meta daemon http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-gmetad < %{version}
Obsoletes: ganglia-monitor-core < %{version}
Provides: ganglia-monitor-core-gmetad = %{version}
Provides: ganglia-monitor-core = %{version}

Requires: AIX-rpm >= 6.1.0.0
Requires: %{name}-lib = %{version}
Requires: rrdtool
Requires: expat >= 2.0.0

%description gmetad
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

This gmetad daemon aggregates monitoring data from several clusters
to form a monitoring grid. It also keeps metric history using rrdtool.


%package gmond
Summary: Ganglia Monitor daemon http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-gmond < %{version}
Obsoletes: ganglia-monitor-core < %{version}
Provides: ganglia-monitor-core-gmond = %{version}
Provides: ganglia-monitor-core = %{version}

Requires: AIX-rpm >= 6.1.0.0
Requires: %{name}-lib = %{version}
Requires: apr  >= 1.3.12
Requires: libconfuse
Requires: expat >= 2.0.0

%description gmond
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

This gmond daemon provides the ganglia service within a single cluster or
Multicast domain.


%package devel
Summary: Ganglia Library http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-lib 

Requires: AIX-rpm >= 6.1.0.0
Requires: %{name}-lib = %{version}
Requires: apr-devel
Requires: libconfuse-devel
Requires: expat-devel >= 2.0.0
Requires: pcre-devel >= 7.9

%description devel
The Ganglia Monitoring Core library provides a set of functions that
programmers can use to build scalable cluster or grid applications.


##
## PREP
##
%prep 
%setup -q

# apply all necessary AIX patches
%patch0
%patch1

##
## BUILD
##
%build
export CONFIG_SHELL=/usr/bin/sh
export APR_CONFIG=/opt/freeware/bin/apr-1-config
export RM="/usr/bin/rm -f"
export CC="/usr/vac/bin/xlc_r -U_AIX43"
export CFLAGS="${CFLAGS} -I/opt/freeware/include/apr-1"
export LDFLAGS="-L/opt/freeware/lib -Wl,-bmaxdata:0x80000000 -Wl,-brtl"
autoreconf -fiv
./configure \
    --prefix=%{_prefix} \
    --sysconfdir=%{conf_dir} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --with-gmetad \
    --disable-python
make %{?_smp_mflags}


##
## INSTALL
##
%install

[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install

## Create the directory structure
%__mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
%__mkdir -p ${RPM_BUILD_ROOT}%{conf_dir}
%__mkdir -p ${RPM_BUILD_ROOT}%{conf_dir}/conf.d
%__mkdir -p ${RPM_BUILD_ROOT}/var/lib/ganglia/rrds

## Move the files into the structure
%__cp -f %{SOURCE2} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/gmetad
%__cp -f %{SOURCE3} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/gmond
chmod 0755 $RPM_BUILD_ROOT/etc/rc.d/init.d/gm*
## Copy our modified gmond.conf file
%__cp -f %{SOURCE1} ${RPM_BUILD_ROOT}%{conf_dir}/gmond.conf
%__cp -f %{_builddir}/%{name}-%{version}/gmond/modules/conf.d/* ${RPM_BUILD_ROOT}%{conf_dir}/conf.d
%__cp -f %{_builddir}/%{name}-%{version}/gmetad/gmetad.conf ${RPM_BUILD_ROOT}%{conf_dir}/gmetad.conf

# Don't install the example modules
%__rm -f ${RPM_BUILD_ROOT}%{conf_dir}/conf.d/example.conf
%__rm -f ${RPM_BUILD_ROOT}%{conf_dir}/conf.d/example.pyconf

# Don't install the status modules
%__rm -f ${RPM_BUILD_ROOT}%{conf_dir}/conf.d/modgstatus.conf

# Clean up the .conf.in files
%__rm -f ${RPM_BUILD_ROOT}%{conf_dir}/conf.d/*.conf.in

mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/
ln -sf '../init.d/gmond' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Sgmond
ln -sf '../init.d/gmond' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kgmond
ln -sf '../init.d/gmond' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Sgmond
ln -sf '../init.d/gmond' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kgmond
ln -sf '../init.d/gmetad' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Sgmetad
ln -sf '../init.d/gmetad' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kgmetad
ln -sf '../init.d/gmetad' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Sgmetad
ln -sf '../init.d/gmetad' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kgmetad


##
## PREUN GMETAD
##
%preun gmetad
if [ "$1" = 0 ]
then
   /etc/rc.d/init.d/gmetad stop
fi


##
## PREUN GMOND
##
%preun gmond
if [ "$1" = 0 ]
then
   /etc/rc.d/init.d/gmond stop
fi


##
## POST GMETAD
##
%post gmetad
if [ "$1" -gt "1" ]; then
   # Upgrading ganglia package - restart gmetad
   /etc/rc.d/init.d/gmetad restart
fi


##
## POST GMOND
##
%post gmond
if [ "$1" -gt "1" ]; then
   # Upgrading ganglia package - restart gmond
   /etc/rc.d/init.d/gmond restart
fi


##
## CLEAN
##
%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


##
## FILES LIB
##
%files lib
%defattr(-,root,system)
%{_libdir}/libganglia*


##
## FILES GMETAD
##
%files gmetad
%defattr(-,root,system)
%attr(0755,nobody,nobody) /var/lib/ganglia/rrds
%{_sbindir}/gmetad
%config(noreplace) %{conf_dir}/gmetad.conf
%{_mandir}/man1/gmetad.1*
/etc/rc.d/init.d/gmetad
/etc/rc.d/rc2.d/Sgmetad
/etc/rc.d/rc2.d/Kgmetad
/etc/rc.d/rc3.d/Sgmetad
/etc/rc.d/rc3.d/Kgmetad


##
## FILES GMOND
##
%files gmond
%defattr(-,root,system)
%attr(0500,root,system) %{_bindir}/gmetric
%attr(0555,root,system) %{_bindir}/gstat
%{_sbindir}/gmond
%{_mandir}/man1/gmetric.1*
%{_mandir}/man1/gmond.1*
%{_mandir}/man1/gstat.1*
%{_mandir}/man5/gmond.conf.5*
%config(noreplace) %{conf_dir}/gmond.conf
%dir %{conf_dir}
%dir %{conf_dir}/conf.d/
%dir %{_libdir}/ganglia/
%{_libdir}/%{name}/modcpu.so
%{_libdir}/%{name}/moddisk.so
%{_libdir}/%{name}/modload.so
%{_libdir}/%{name}/modmem.so
%{_libdir}/%{name}/modnet.so
%{_libdir}/%{name}/modproc.so
%{_libdir}/%{name}/modsys.so
/etc/rc.d/init.d/gmond
/etc/rc.d/rc2.d/Sgmond
/etc/rc.d/rc2.d/Kgmond
/etc/rc.d/rc3.d/Sgmond
/etc/rc.d/rc3.d/Kgmond


##
## FILES DEVEL
##
%files devel
%defattr(-,root,system)
%{_bindir}/ganglia-config
%{_includedir}/ganglia_gexec.h
%{_includedir}/ganglia.h
%{_includedir}/gm_file.h
%{_includedir}/gm_metric.h
%{_includedir}/gm_mmn.h
%{_includedir}/gm_msg.h
%{_includedir}/gm_protocol.h
%{_includedir}/gm_value.h


##
## CHANGELOG
##
%changelog
* Wed Jul 25 2012 Patricia Cugny <patricia.cugny@bull.net> 3.4.0-2
-  update to version 3.4.0 on aix 6.1
 
* Mon May 28 2012 Michael Perzl <michael@perzl.org> - 3.4.0-1
- updated to version 3.4.0

* Mon May 21 2012 Gerard Visiedo <gerard.visiedo@bull.net> 3.3.7-2
- Port on Aix61

* Sun May 06 2012 Michael Perzl <michael@perzl.org> - 3.3.7-1
- updated to version 3.3.7

* Fri Apr 20 2012 Michael Perzl <michael@perzl.org> - 3.3.6-1
- updated to version 3.3.6

* Wed Apr 11 2012 Michael Perzl <michael@perzl.org> - 3.3.5-1
- updated to version 3.3.5

* Thu Feb 09 2012 Michael Perzl <michael@perzl.org> - 3.3.1-1
- updated to version 3.3.1

* Thu Feb 09 2012 Michael Perzl <michael@perzl.org> - 3.2.0-2
- fixed the termination signal in the gmond and gmetad startup scripts

* Thu Oct 13 2011 Michael Perzl <michael@perzl.org> - 3.2.0-1
- updated to version 3.2.0

* Wed Oct 12 2011 Michael Perzl <michael@perzl.org> - 3.1.7-4
- fixed the cpu properties (user, sys, idle, wait)

* Wed Nov 17 2010 Michael Perzl <michael@perzl.org> - 3.1.7-3
- fixed an error in the gmond init.d script

* Thu Sep 02 2010 Michael Perzl <michael@perzl.org> - 3.1.7-2
- moved all additional modules into separate RPM files
- improved gmetad and gmond start/stop scripts

* Fri May 07 2010 Michael Perzl <michael@perzl.org> - 3.1.7-1
- updated to version 3.1.7

* Tue Apr 27 2010 Michael Perzl <michael@perzl.org> - 3.1.2-5
- added sanity check for cpu_pool_idle_func()
- added firmware version metric (--> fwversion_func() )

* Fri Apr 16 2010 Michael Perzl <michael@perzl.org> - 3.1.2-4
- added IO ops/sec metric (--> disk_iops_func() )
- changed metric type from GANGLIA_VALUE_FLOAT to GANGLIA_VALUE_DOUBLE for
  disk_read_func() and disk_write_func()
- added the mod_ibmrperf module with "rperf" and "specint" metrics

* Thu Jan 21 2010 Michael Perzl <michael@perzl.org> - 3.1.2-3
- improved cpu_used for non micropartitioned systems
- fixed defuncts caused by open pipes (--> popen() without pclose() )
- added checks for possible libperfstat counter resets

* Sun Oct 04 2009 Michael Perzl <michael@perzl.org> - 3.1.2-2
- added the mod_ibmams module für IBM AMS (Active Memory Sharing)

* Fri Feb 20 2009 Michael Perzl <michael@perzl.org> - 3.1.2-1
- updated to Ganglia v3.1.2, enabled DSOs on AIX

* Tue Mar 25 2008 Michael Perzl <michael@perzl.org> - 3.0.7-1
- updated for Ganglia v3.0.7

* Tue Mar 25 2008 Michael Perzl <michael@perzl.org> - 3.0.6-1
- updated for Ganglia v3.0.6

* Mon Oct 08 2007 Michael Perzl <michael@perzl.org> - 3.0.5-1
- updated for Ganglia v3.0.5

* Wed Jul 11 2007 Michael Perzl <michael@perzl.org> - 3.0.4-2
- fixed the network counter overflow error on AIX

* Wed Jan 10 2007 Michael Perzl <michael@perzl.org> - 3.0.4-1
- adapted for Ganglia v3.0.4

* Fri Apr 21 2006 Michael Perzl <michael@perzl.org> - 3.0.3-1
- adapted for Ganglia v3.0.3

* Thu Feb 23 2006 Michael Perzl <michael@perzl.org>
- first version for AIX V5.1 and higher, based on the original Ganglia SPEC file
